net.sourceforge.pmd.lang.java.rule.comments

## Class CommentRequiredRule

- java.lang.Object
- - net.sourceforge.pmd.AbstractPropertySource
  - - net.sourceforge.pmd.lang.rule.AbstractRule
    - - net.sourceforge.pmd.lang.java.rule.AbstractJavaRule
      - - net.sourceforge.pmd.lang.java.rule.comments.AbstractCommentRule
        - - net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule

All Implemented Interfaces:
  JavaParserVisitor, ImmutableLanguage, PropertySource, Rule

    public class CommentRequiredRule
    extends AbstractCommentRule

Author:
  Brian Remedios

### Field Summary

Fields
`static EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement>` `FIELD_CMT_REQUIREMENT_DESCRIPTOR`
`static EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement>` `HEADER_CMT_REQUIREMENT_DESCRIPTOR`
`static EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement>` `PROT_METHOD_CMT_REQUIREMENT_DESCRIPTOR`
`static EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement>` `PUB_METHOD_CMT_REQUIREMENT_DESCRIPTOR`

### Fields inherited from class net.sourceforge.pmd.AbstractPropertySource

`propertyDescriptors, propertyValuesByDescriptor`

### Fields inherited from interface net.sourceforge.pmd.Rule

`VIOLATION_SUPPRESS_REGEX_DESCRIPTOR, VIOLATION_SUPPRESS_XPATH_DESCRIPTOR`

### Constructor Summary

Constructors
Constructor and Description
`CommentRequiredRule()`

### Method Summary

Methods
`boolean` `allCommentsAreIgnored()`
`String` `dysfunctionReason()` Returns a description of why the receiver may be dysfunctional.
`Object` `visit(ASTCompilationUnit cUnit, Object data)`

### Methods inherited from class net.sourceforge.pmd.lang.java.rule.comments.AbstractCommentRule

`filteredCommentIn, orderedCommentsAndDeclarations, tagsIndicesIn`

### Methods inherited from class net.sourceforge.pmd.lang.java.rule.AbstractJavaRule

`apply, getDeclaringType, importsPackage, isQualifiedName, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visitAll`

### Methods inherited from class net.sourceforge.pmd.lang.rule.AbstractRule

`addExample, addRuleChainVisit, addRuleChainVisit, addViolation, addViolation, addViolation, addViolationWithMessage, addViolationWithMessage, addViolationWithMessage, deepCopyValuesTo, end, equals, getDescription, getExamples, getExternalInfoUrl, getLanguage, getMaximumLanguageVersion, getMessage, getMinimumLanguageVersion, getName, getParserOptions, getPriority, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, hashCode, isDeprecated, setDeprecated, setDescription, setExternalInfoUrl, setLanguage, setMaximumLanguageVersion, setMessage, setMinimumLanguageVersion, setName, setPriority, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

### Methods inherited from class net.sourceforge.pmd.AbstractPropertySource

`copyPropertyDescriptors, copyPropertyValues, definePropertyDescriptor, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.sourceforge.pmd.PropertySource

`definePropertyDescriptor, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Field Detail

#### HEADER_CMT_REQUIREMENT_DESCRIPTOR

    public static final EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement> HEADER_CMT_REQUIREMENT_DESCRIPTOR

#### FIELD_CMT_REQUIREMENT_DESCRIPTOR

    public static final EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement> FIELD_CMT_REQUIREMENT_DESCRIPTOR

#### PUB_METHOD_CMT_REQUIREMENT_DESCRIPTOR

    public static final EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement> PUB_METHOD_CMT_REQUIREMENT_DESCRIPTOR

#### PROT_METHOD_CMT_REQUIREMENT_DESCRIPTOR

    public static final EnumeratedProperty<net.sourceforge.pmd.lang.java.rule.comments.CommentRequiredRule.CommentRequirement> PROT_METHOD_CMT_REQUIREMENT_DESCRIPTOR

### Constructor Detail

#### CommentRequiredRule

    public CommentRequiredRule()

### Method Detail

#### visit

    public Object visit(ASTCompilationUnit cUnit,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `AbstractJavaRule`

#### allCommentsAreIgnored

    public boolean allCommentsAreIgnored()

#### dysfunctionReason

    public String dysfunctionReason()

Description copied from interface: `PropertySource`
Returns a description of why the receiver may be dysfunctional. Usually due to missing property values or some kind of conflict between values. Returns null if the receiver is ok.

Specified by:
  `dysfunctionReason` in interface `PropertySource`
Overrides:
  `dysfunctionReason` in class `AbstractPropertySource`
Returns:
  String
See Also:
  `PropertySource.dysfunctionReason()`